;
;ATTAK.ASM
;   (c)1989 B.RIVE
;   Gestion des attaques d'une region par un lord.
;
;ATTAQUE(B:Lord,C:Reg) -> CARRY si fin (A:1->gagne,2->perdu)
;
ALORD    DEFS 1
AREG     DEFS 1
DLORD    DEFS 1
DREG     DEFS 1
ARMEE    DEFS 2
;
ATTAQUE
         PUSH BC
         PUSH DE
         PUSH HL
         PUSH IX
         PUSH IY

         CALL ATT_PAR
         CALL ATT_MESS
         CALL ATT_DEFR
         CALL ATT_TRAN
         CALL ATT_CAST
         CALL ATT_COMB
         JR   C,ATTI_WON
         JR   Z,ATTI_LOS
         CALL ATT_RETR
         JR   ATT_END
ATTI_WON CALL ATT_WON
         JR   ATT_END
ATTI_LOS CALL ATT_LOST

ATT_END
         PUSH AF
         CALL AFFINC
         POP  AF

         POP  IY
         POP  IX
         POP  HL
         POP  DE
         POP  BC
         RET
;
;ATT_PAR
;   Initialisation des variables
ATT_PAR
         LD   A,B
         LD   (ALORD),A
         CALL LGETREG
         LD   (AREG),A
         LD   A,C
         LD   (DREG),A
         CALL RGETPROP
         LD   (DLORD),A
         RET
;
;ATT_MESS
;   Affichage du message
ATT_MESS
         CALL ISO_VIER
         RET  Z

         CALL ISD_JOU
         JR   NZ,NO_DJOU

         CALL ISO_NOB
         JR   NZ,NO_EMBU
         CALL Z,ISO_PROT
         RET  NZ
         LD   A,(DREG)
         CALL GETRNAME
         PUSH HL
         LD   A,(ALORD)
         CALL GETLNAME
         PUSH HL
         LD   HL,EMBUSC
         JR   YEMESS
NO_EMBU
         CALL ISO_GARN
         JR   NZ,NO_GARN
         CALL ISO_PROT
         JR   Z,YE_GARN
         CALL ISO_NEAR
         JR   NZ,NO_DJOU
YE_GARN  LD   A,(ALORD)
         CALL GETLNAME
         PUSH HL
         LD   A,(DREG)
         CALL GETRNAME
         PUSH HL
         LD   HL,GARNISON
         JR   YEMESS
NO_GARN
         CALL ISO_HOME
         RET  NZ
         LD   A,(ALORD)
         CALL GETLNAME
         PUSH HL
         LD   HL,HOMEATT
YEMESS   LD   A,5
         CALL PLACARD
         RET

NO_DJOU
         CALL ISA_JOU
         RET  NZ
         CALL ISO_PROT
         RET  NZ
         LD   A,(DLORD)
         CALL GETLNAME
         PUSH HL
         LD   HL,DISCOV
         JR   YEMESS
;
;ATT_DEFR
;   Retour du defenseur
ATT_DEFR
         CALL ISO_NOB
         RET  Z
         CALL ISO_NEAR
         RET  NZ
         CALL ISD_JOU
         JR   NZ,COMNOJ
         CALL WISH
         LD   A,(DREG)
         CALL C,RAMENE
         RET
COMNOJ   CALL ISA_JOU
         JR   NZ,COMNOJ2
         LD   A,(DLORD)
         CALL GETLNAME
         PUSH HL
         LD   HL,COMEBACK
         LD   A,5
         CALL PLACARD
COMNOJ2  LD   A,(DREG)
         CALL RAMENE
         RET
;
;ATT_TRAN
;   Transfert de l'armee du defenseur
ATT_TRAN
         CALL ISO_VIER
         RET  Z
         CALL ISO_PROT
         LD   A,(DREG)
         CALL Z,TRANSFER
         RET
;
;ATT_CAST
;   Mise en place CASTRESI
ATT_CAST
         XOR  A
         LD   (CASTRESI),A
         CALL ISO_NOB
         RET  Z
         CALL ISA_JOU
         JR   NZ,NOSIEGE
         CALL MUSBUF+3            ;Stoppe le bruit
         LD   A,(DLORD)           ;Jeu de la catapulte
         LD   B,A
         LD   A,(DREG)
         LD   C,A
         LD   A,(ALORD)
         CALL RUNFILE
         DEFW SIEGE
         LD   (CASTRESI),A
         LD   HL,EVENT
         LD   DE,BUFOVL
         CALL READFIL2
         LD   HL,SONS
         LD   DE,MUSBUF
         CALL READFIL2
         RET
NOSIEGE  LD   A,7
         CALL RND
         ADD  A,3
         LD   (CASTRESI),A
         CALL ISD_JOU
         RET  NZ
         CALL ISO_HOME
         JR   Z,YESHOW
         CALL ISO_PROT
         RET  NZ
YESHOW   LD   A,(CASTRESI)
         CALL SHOWCAST
         RET
;
;ATT_COMB
;   Execution du combat
ATT_COMB
         CALL ISA_JOU
         JR   NZ,NO_INC0
         CALL ISO_VIER
         LD   A,(DLORD)
         CALL NZ,LINCHATE
NO_INC0  LD   A,(ALORD)
         CALL LGETARM
         LD   (ARMEE),HL
         LD   A,(ALORD)
         CALL GETLORD
         LD   A,(DREG)
         CALL GETREG
         LD   HL,CASTRESI
         CALL BUFOVL+3

         PUSH AF
         CALL AFFARM
         CALL ISO_VIER
         JR   NZ,PASVIER
         LD   A,(DREG)
         CALL GETREG
         LD   A,(IX+09)
         LD   (IX+01),A
PASVIER  POP  AF
         RET
;
;ATT_WON
;   Victoire
ATT_WON
         CALL ISO_VIER
         JR   Z,NORAPA
         LD   A,(LORD)
         CALL LGETREG
         LD   B,A
         LD   A,(DREG)
         CP   B
         JR   NZ,NODEGAGE
         LD   A,(LORD)
         CALL RAPATRIE
NODEGAGE
         CALL ISO_PROT
         LD   A,(DLORD)
         CALL Z,RAPATRIE
NORAPA
         CALL ISO_HOME
         JR   Z,MURDER
         CALL ISO_VIER
         JR   NZ,WONPASV
         CALL ISA_JOU
         JR   NZ,WONPASV
         LD   A,(ALORD)
         CALL LGETARM
         EX   DE,HL
         LD   HL,(ARMEE)
         OR   A
         SBC  HL,DE
         LD   A,L
         CP   1
         LD   DE,HOMME
         JR   Z,UNSEUL
         LD   DE,HOMMES
UNSEUL   PUSH DE
         PUSH HL
         LD   HL,VASSWIN
         LD   A,5
         CALL PLACARD
WONPASV
         LD   A,(DREG)
         LD   C,A
         LD   A,(ALORD)
         LD   B,A
         CALL DONNE
         LD   A,(ALORD)
         CALL DEPLACE
         XOR  A
         RET
MURDER
         LD   A,(DLORD)
         LD   B,A
         LD   A,(ALORD)
         LD   C,A
         CALL DEPOUIL
         LD   A,(DREG)
         LD   C,A
         LD   A,(ALORD)
         CALL DEPLACE

         CALL ISD_JOU
         JR   NZ,PASPERDU
         LD   A,(DLORD)
         CALL GETLORD
         CALL KILL
         XOR  A
         LD   (IY+07),A
         LD   A,(DREG)
         CALL AFFREG
         LD   A,2
         SCF
         RET

PASPERDU
         LD   A,(DLORD)
         CALL KILL
         CALL ISA_JOU
         JR   NZ,WON_NOJ
         LD   A,(LORD)
         LD   B,A
         LD   A,9
CHHATE   CP   B
         CALL NZ,LINCHATE
         DEC  A
         JR   NZ,CHHATE
         LD   A,(DLORD)
         CALL GETLNAME
         PUSH HL
         LD   HL,LORDEAD
         LD   A,7
         CALL PLACARD
         LD   C,5                 ;Test dernier normand
MVLASTN  LD   A,C
         CALL ISDEAD
         JR   NZ,MVNOEND
         INC  C
         LD   A,10
         CP   C
         JR   NZ,MVLASTN
         LD   A,1
         SCF
         RET
MVNOEND
         XOR  A
         RET

WON_NOJ
         LD   A,(ALORD)
         CALL GETLNAME
         PUSH HL
         LD   A,(DLORD)
         CALL GETLNAME
         PUSH HL
         LD   HL,DESTROY
         LD   A,5
         CALL PLACARD
         JR   MVNOEND
;
;ATT_LOST
;   Defaite
ATT_LOST
         CALL ISA_JOU
         JR   NZ,LOSSNOM
         CALL ISO_VIER
         JR   NZ,LOSSNOM
         LD   HL,VLTXT
         LD   A,5
         CALL PLACARD
LOSSNOM  LD   A,(ALORD)
         CALL RAPATRIE
         XOR  A
         RET
;
;ATT_RETR
;   Retraite
ATT_RETR
         LD   A,(AREG)
         CALL GETRNAME
         PUSH HL
         LD   A,(ALORD)
         CALL GETLNAME
         PUSH HL
         LD   HL,RETRAITE
         LD   A,7
         CALL PLACARD
         XOR  A
         RET

;
WISH
         LD   HL,WISHTXT
         CALL MENUTEXT
         CALL MENUREST
         CP   2
         RET
WISHTXT  DEFB 10,10,20
         DEFB #FE,"Aller d[fendre",#FE,#F9
         DEFB #FE,"Laisser r[sister",#FE,#FF
;
SHOWCAST
         ADD  A,38
         PUSH AF
         LD   HL,SCASTLE
         LD   DE,BUFIMA
         CALL READFILE
         CALL BLACKOUT
         LD   HL,BUFIMA
         CALL DECOMP
         LD   HL,CATSPR
         LD   DE,SPRBUF
         CALL READFILE
         LD   A,2           ;CATAPULTE
         LD   HL,256*64+57
         CALL AFFSPR
         LD   A,3           ;SOLDATS
         LD   HL,256*8+68
         CALL AFFSPR
         LD   A,4           ;CHEVALIER
         LD   HL,256*128+98
         CALL AFFSPR
         LD   HL,CATANIM
         LD   DE,SPRBUF
         CALL READFILE
         LD   A,1
         LD   HL,256*80+58
         CALL AFFSPR         ;PANIER
         POP  AF
         LD   HL,256*82+123
         CALL AFFSPR
         LD   A,4
         CALL BRUIT
         LD   HL,BUFIMA
         CALL SETPAL
         CALL SETFLASH
         LD   B,6
         LD   C,B
         LD   A,9
         CALL #BC32          ;SCR SET INK
         LD   A,6
         CALL PAUSE
         RET
;
;
;Fonctions de test
;
TAMP     DEFS 1
;
;Attaquant=joueur?
ISA_JOU
         LD   (TAMP),A
         LD   A,(ALORD)
         CALL ISJOUEUR
         LD   A,(TAMP)
         RET
;Defenseur=joueur?
ISD_JOU
         LD   (TAMP),A
         LD   A,(DLORD)
         CALL ISJOUEUR
         LD   A,(TAMP)
         RET
;Objectif=vierge?
ISO_VIER
         LD   (TAMP),A
         LD   A,(DLORD)
         OR   A
         LD   A,(TAMP)
         RET
;Objectif sans building?
ISO_NOB
         LD   (TAMP),A
         LD   A,(DREG)
         CALL RGETBUIL
         OR   A
         LD   A,(TAMP)
         RET
;Objectif=home?
ISO_HOME
         PUSH BC
         LD   C,A
         LD   A,(DLORD)
         OR   A
         JR   NZ,ISO_HOM0
         LD   A,1
         OR   A
         POP  BC
         RET
ISO_HOM0 CALL LGETHOME
         LD   B,A
         LD   A,(DREG)
         CP   B
         LD   A,C
         POP  BC
         RET
;Objectif=garnison?
ISO_GARN
         LD   (TAMP),A
         LD   A,(DREG)
         CALL RGETBUIL
         CP   3
         LD   A,(TAMP)
         RET
;Objectif has proprietary?
ISO_PROT
         LD   (TAMP),A
         LD   A,(DREG)
         CALL LORDHERE
         LD   A,(TAMP)
         RET
;Proprietaire pas loin de l'objectif?
ISO_NEAR
         LD   (TAMP),A
         LD   A,(DREG)
         CALL LORDNEAR
         LD   A,0
         JR   C,ISO_NEA0
         LD   A,1
ISO_NEA0 OR   A
         LD   A,(TAMP)
         RET


