;*******************************************************************************
;DISC.ASM                                                                      *
;   Lectures disque pour DEFENDER OF THE CROWN                                 *
;        (c)1988 B.RIVE                                                        *
;*******************************************************************************
;READFILE : Lecture d'un fichier
;   ENTRY : HL-> Adresse du nom sur 12 octets.
;           DE-> Adresse d'implantation.
;   EXIT  : BC-> Nombre d'octets lus.
;           DE-> Adresse premier octet suivant le fichier lu.
;           MODIFIES: BC,DE,AF,HL
;*******************************************************************************
;RUNFILE  : Lecture et execution d'un fichier
;   ENTRY : HL-> Adresse du nom sur 12 octets.
;*******************************************************************************
;
         EXTRA
;
DEFIRST  EQU  1
REGBUF   DEFS 2
;
RUNFILE
         LD   (REGBUF),DE
         EX   (SP),HL
         LD   E,(HL)
         INC  HL
         LD   D,(HL)
         INC  HL
         EX   (SP),HL
         EX   DE,HL
         PUSH BC
         PUSH AF
         PUSH DE
         LD   DE,BUFOVL
         CALL READFIL2
         POP  HL
         POP  AF
         POP  BC
         LD   DE,(REGBUF)
         JP   BUFOVL
;
DEFSIDE  DEFB 0
;
READFILE
         LD   BC,#40
         LD   (SAVEBUF),BC
READFIL2 LD   A,(HL)
         LD   (SIDESTR),A
         LD   C,A
         INC  HL
         PUSH IX
         PUSH IY
         LD   (ECRADD+1),DE
         LD   (DEFRDF10+1),HL
         LD   A,(DEFSIDE)
         CP   C
         LD   A,C
         LD   (DEFSIDE),A
         JR   Z,DEFRDF10
DEFRDFI0 CALL DEFRDDIR
DEFRDF10 LD   HL,0
         CALL OPEN
         CALL NC,DEFERR
         JR   NC,DEFRDFI0
         CALL DIRECT
         LD   (NEXTADD),DE
ECRADD   LD   DE,0
         CALL C,DEFCODE
         CALL C,CHECKSUM
         JR   NC,DEFRDFI0
         LD   DE,(NEXTADD)
         POP  IY
         POP  IX
         CALL MOTOFF
         RET
NEXTADD  DEFS 2
;
;CHECKSUM
;   Calcul du checksum d'un fichier non code
;INPUT:  IY-> Entree dans la directory
;        DE-> Adresse debut fichier
;OUTPUT: CARRY -> Checksum OK
;
CHECKSUM
         PUSH HL
         PUSH BC
         PUSH IY
         CALL CALCSUM
         PUSH HL
         LD   BC,10
         ADD  IY,BC
         LD   HL,0
         LD   B,11
CHKS0    LD   A,(IY+00)
         RLA
         RL   L
         RL   H
         DEC  IY
         DJNZ CHKS0
         POP  BC
         OR   A
         SBC  HL,BC
         JR   Z,CHKS1
         SCF
CHKS1    CCF
         POP  IY
         POP  BC
         POP  HL
         RET
;
CALCSUM
         PUSH AF
         PUSH BC
         PUSH DE
         EX   DE,HL
         LD   C,(IY+14)
         LD   B,(IY+15)
         LD   DE,0
CALSUM0
         LD   A,(HL)
         ADD  A,E
         LD   E,A
         JR   NC,CALSUM1
         INC  D
CALSUM1  INC  HL
         DEC  BC
         LD   A,B
         OR   C
         JR   NZ,CALSUM0
         EX   DE,HL
         LD   A,#07
         AND  H
         LD   H,A
         POP  DE
         POP  BC
         POP  AF
         RET
;
;OPEN
;   Ouverture d'un fichier
;INPUT:  HL-> Adresse nom
;OUTPUT: IY-> Entree directory
;        BC-> Longueur
;        HL-> Offset premier secteur
;        A -> Premiere piste
;
OPEN
         PUSH DE
         LD   C,NBENT
         LD   IY,DIRBUF
         LD   DE,SZENT
OPEN0    LD   B,8            ;Compare nom
         PUSH HL
         PUSH IY
OPEN1    LD   A,(IY+00)
         AND  #7F
         CP   (HL)
         JR   NZ,OPEN2
         INC  HL
         INC  IY
         DJNZ OPEN1
         INC  HL             ;Compare extension
         LD   B,3
OPEN1BIS LD   A,(IY+00)
         AND  #7F
         CP   (HL)
         JR   NZ,OPEN2
         INC  HL
         INC  IY
         DJNZ OPEN1BIS
OPEN2    POP  IY
         POP  HL
         JR   Z,OPEN3
         ADD  IY,DE
         DEC  C
         JR   NZ,OPEN0
         POP  DE
         RET
OPEN3    LD   L,(IY+11)
         LD   H,(IY+12)
         LD   A,(IY+13)
         LD   BC,PISTSIZE
         LD   D,DEFIRST-1
OPEN4    SBC  HL,BC
         SBC  A,0
         INC  D
         JR   NC,OPEN4
         ADD  HL,BC
         LD   C,(IY+14)
         LD   B,(IY+15)
         LD   A,D
         POP  DE
         RET
;
;DIRECT
;   Lecture des octets sur le disque
;INPUT:  IY->Entree dans la directory
;        DE->Adresse d'implantation
;        BC->Nombre d'octets
;        HL->Offset premier secteur
;        A ->Premiere piste
;OUPUT:  CARRY->Lecture OK
;        DE->Adresse octet suivant
;Modifies:AF,IX
DIRECT
         PUSH BC
         PUSH DE
         POP  IX
DIRECT1  EX   DE,HL
         LD   HL,PISTSIZE
         OR   A
         SBC  HL,DE
         PUSH HL
         OR   A
         SBC  HL,BC
         POP  HL
         JR   C,DIRECT2
         LD   H,B
         LD   L,C
DIRECT2  EX   DE,HL
         PUSH DE             ;MIN[(PISTSIZE-Offset),Longueur]
         PUSH AF             ;Piste
         OR   A
         CALL DEFREAD
         JR   NC,DIRECT3
         POP  AF
         INC  A
         LD   H,B
         LD   L,C
         POP  DE
         OR   A
         SBC  HL,DE
         LD   B,H
         LD   C,L
         LD   HL,#0000
         JR   NZ,DIRECT1
         PUSH IX
         POP  DE
         POP  BC
         SCF
         RET
DIRECT3  POP  AF
         POP  DE
         POP  BC
         OR   A
         RET
;
;
;DEFCODE
;   Decodage d'un ficher lu
;INPUT:  IY-> Entree dans la directory
;        DE-> Adresse debut fichier
;Modifies: Aucun
;
DEFCODE
         DI
         PUSH AF
         PUSH BC
         PUSH DE
         EX   DE,HL
         LD   C,(IY+14)
         LD   B,(IY+15)
         LD   A,(IY+13)
         LD   R,A
DEFCOD1  LD   A,R
         XOR  (HL)
         LD   (HL),A
         INC  HL
         DEC  BC
         LD   A,B
         OR   C
         JR   NZ,DEFCOD1
         EX   DE,HL
         POP  DE
         POP  BC
         POP  AF
         EI
         RET
;
DEFRDDIR
         PUSH HL
         PUSH AF
         PUSH DE
         PUSH IX
DEFRDDI1 LD   HL,#0000
         LD   IX,DIRBUF
         LD   DE,NBENT*SZENT
         LD   A,DEFIRST
         SCF
         CALL DEFREAD
         CALL NC,DEFERR
         JR   NC,DEFRDDI1
         POP  IX
         POP  DE
         POP  AF
         POP  HL
         RET
;
;DEFREAD
;   Lecture d'un secteur
;INPUT:  CARRY-> Recalibrate
;        A -> No piste
;        HL-> Offset sur piste
;        IX-> Adresse d'implantation
;        DE-> Nombre d'octets a lire
;OUTPUT: CARRY -> Lecture OK
;        IX-> Adresse octet suivant le dernier lu
;        HL-> 0
;Modifies: AF,DE
;
DEFREAD
         PUSH DE
         LD   D,A
         CALL SEEK
         LD   A,D
         POP  DE
         RET  NC
         DI   
         PUSH BC
         PUSH DE
         LD   D,A
         LD   A,#46                    ;Ecrire donnees
         CALL FDCOUT
         LD   A,0                      ;Drive
         CALL FDCOUT
         LD   A,D                      ;Piste
         CALL FDCOUT
         LD   A,0                      ;Tete
         CALL FDCOUT
         LD   A,0                      ;Secteur
         CALL FDCOUT
         LD   A,6                      ;Taille secteur (8Ko)
         CALL FDCOUT
         LD   A,0                      ;Dernier secteur
         CALL FDCOUT
         LD   A,#2A                    ;GAP #3
         CALL FDCOUT
         LD   A,#FF                    ;Longueur secteur
         CALL FDCOUT
         POP  DE
         CALL DATAIN
         CALL RESULT
         CALL TSTRESU
         DEFB #40,#20,#20
         POP  BC
         EI
         RET  
;
;SEEK(D:Piste,Carry:Recalibrate)->Carry:OK
;
TENTATIV EQU  10
PISTACT  DEFB 0
;
SEEK
         CALL MOTON
         PUSH HL
         PUSH BC
         LD   B,TENTATIV
         JR   NC,NRECAL
AGAIN    PUSH BC
         DI
         LD   A,#07
         CALL FDCOUT
         XOR  A
         CALL FDCOUT
         LD   A,#2A
         CALL FDCSTAT
         JR   NC,ERROR0
         LD   (PISTACT),A
         EI
         POP  BC
NRECAL   LD   HL,PISTACT
         LD   A,(HL)
         SUB  D
         SCF  
         JR   Z,SEEKF
         PUSH BC
         DI
         LD   A,#0F
         CALL FDCOUT
         XOR  A
         CALL FDCOUT
         LD   A,D
         CALL FDCOUT
         LD   A,D
         SUB  (HL)
         JR   NC,DELTAPOS
         LD   A,(HL)
         SUB  D
DELTAPOS LD   (HL),D
         CALL FDCSTAT
         EI
ERROR0   POP  BC
         JR   C,SEEKF
         DEC  B
         JR   Z,SEEKF
         CALL INTSTAT
         JR   AGAIN
SEEKF    POP  BC
         POP  HL
         RET
;
FDCSTAT
;        PUSH AF
;        LD   A,#0C
;        CALL TEMPMILI
;        POP  AF
;        DEC  A
;        JR   NZ,FDCSTAT
;        LD   A,#0F
;        CALL TEMPMILI
         LD   A,#08
         CALL FDCOUT
         CALL RESULT
         LD   A,(RESBUF)
         CP   #80
         JR   Z,FDCSTAT
         AND  #C0
         RET  NZ
         SCF
         RET  
;
TEMPMILI
         PUSH AF
         LD   A,#F6
TEMP1    DEC  A
         JR   NZ,TEMP1
         POP  AF
         DEC  A
         JR   NZ,TEMPMILI
         RET  
;
INTSTAT
         PUSH BC
         DI
         LD   BC,#FB7E
INTAGAIN LD   A,#08
         CALL FDCOUT
         CALL RESULT
         LD   A,(RESBUF)
         CP   #80
         JR   NZ,INTAGAIN
         EI
         POP  BC
         RET  
;
MOTEUR   EQU  #FA7E
MOTFLAG  DEFB 0
;
MOTON
         PUSH DE
         PUSH HL
         PUSH AF
         PUSH BC
         CALL DELTICK
         LD   A,(MOTFLAG)
         OR   A
         JR   NZ,MOTONF
         LD   BC,MOTEUR
         LD   A,1
         OUT  (C),A
         LD   DE,50
         LD   HL,MOTICK
         LD   BC,0
         CALL #BCE9
MOTEMP   LD   A,(MOTFLAG)
         OR   A
         JR   Z,MOTEMP
MOTONF   POP  BC
         POP  AF
         POP  HL
         POP  DE
         RET  
;
MOTOFF
         PUSH DE
         PUSH BC
         PUSH AF
         PUSH HL
         LD   HL,MOTICK
         LD   BC,0
         LD   DE,500
         CALL #BCE9
         POP  HL
         POP  AF
         POP  BC
         POP  DE
         RET
;
MOTICKER
         LD   HL,MOTFLAG
         LD   A,(HL)
         CPL
         LD   (HL),A
         OR   A
         JR   Z,TICKER0
DELTICK  LD   HL,MOTICK
         JP   #BCEC
TICKER0  CALL DELTICK
         LD   BC,#FA7E
         XOR  A
         OUT  (C),A
         RET
;
MOTICK   DEFS 6
MOTEVENT DEFS 7
;
;
;DATAIN
;   Reception des octets desires
;INPUT:  HL->Nombre d'octets avant
;        DE->Nombre d'octets bons
;        IX->Adresse d'implantation
;        BC->#FB7E
;OUTPUT: HL->00
;        DE->00
;        IX->Adresse octet suivant
;        BC->#FB7E
;
DATAIN0  INC  C
         IN   A,(C)
         DEC  C
         DEC  HL
DATAIN   LD   A,H
         OR   L
         JR   Z,DATAIN2
DATAIN1  IN   A,(C)
         JP   P,DATAIN1
         AND  #20
         JR   NZ,DATAIN0
         RET
DATAIN2  PUSH IX
         POP  HL
         JR   DATAIN4
DATAIN3  INC  C
         INI
         DEC  C
         INC  B
         DEC  DE
         LD   A,D
         OR   E
         JR   Z,DATAIN5
DATAIN4  IN   A,(C)
         JP   P,DATAIN4
         AND  #20
         JR   NZ,DATAIN3
         RET
DATAIN5  PUSH HL
         POP  IX
         LD   HL,0
         JR   DATAIN1
;
;
;
FDCOUT
         LD   BC,#FB7E
         PUSH AF
WAITRQM  IN   A,(C)
         ADD  A,A
         JR   NC,WAITRQM
         ADD  A,A
         JR   NC,OKOUT
         POP  AF
         RET  
OKOUT    POP  AF
         INC  C
         OUT  (C),A
         DEC  C
         LD   A,05
FDCTEMP  DEC  A
         NOP
         JR   NZ,FDCTEMP
         RET  
;
RESULT
         PUSH HL
         LD   HL,RESBUF
RESAGAIN IN   A,(C)
         CP   #C0
         JR   C,RESAGAIN
         INC  C
         IN   A,(C)
         DEC  C
         LD   (HL),A
         INC  HL
         LD   A,#05
RESTEMP  DEC  A
         JR   NZ,RESTEMP
         IN   A,(C)
         AND  #10
         JR   NZ,RESAGAIN
         POP  HL
         RET
;
TSTRESU
         EX   (SP),HL
         PUSH DE
         PUSH BC
         LD   DE,RESBUF
         LD   BC,#0300
TSTRESU0 LD   A,(DE)
         CP   (HL)
         JR   NZ,TSTRESU1
         INC  C
TSTRESU1 INC  HL
         INC  DE
         DJNZ TSTRESU0
         LD   A,2
         CP   C
         POP  BC
         POP  DE
         EX   (SP),HL
         RET
;
;
DEFERR
         PUSH HL
         PUSH IX
         PUSH AF
         PUSH BC
         PUSH DE
         LD   HL,#0B18
         CALL #BC1A
         PUSH HL
         LD   C,8
         LD   DE,#C7D0
DEFERR2  PUSH BC
         PUSH HL
         LD   BC,#30
         LDIR
         LD   HL,#7D0
         ADD  HL,DE
         EX   DE,HL
         POP  HL
         CALL NEXTLINE
         POP  BC
         DEC  C
         JR   NZ,DEFERR2
         LD   HL,#0C19
         CALL #BB75
         LD   HL,ERRTEXT
         LD   B,17
DEFERR1  LD   A,(HL)
         CALL #BB5A
         INC  HL
         DJNZ DEFERR1
         LD   A,7
         CALL #BB5A
DEFERR0  CALL GETJOY
         JR   NC,DEFERR0
         POP  HL
         LD   C,8
         LD   DE,#C7D0
DEFERR3  PUSH BC
         PUSH HL
         LD   BC,#30
         EX   DE,HL
         LDIR
         EX   DE,HL
         LD   HL,#7D0
         ADD  HL,DE
         EX   DE,HL
         POP  HL
         CALL NEXTLINE
         POP  BC
         DEC  C
         JR   NZ,DEFERR3
         POP  DE
         POP  BC
         POP  AF
         POP  IX
         POP  HL
         RET
;
ERRTEXT  DEFB "Ins[rez la face "
SIDESTR  DEFB "A"
;
RESBUF   EQU  TAMPON         ;7
;


