;
;LINK.ASM
;
;Declaration de la bibliotheque
;
FIRST    EQU  #40
LAST     EQU  #B100
FIN      EQU  #8A00
BUFIMA   EQU  FIRST
SPRBUF   EQU  BUFIMA+16
NBENT    EQU  64
SZENT    EQU  16
DIRBUF   EQU  -NBENT*SZENT+LAST
MUSBUF   EQU  DIRBUF-#B00
BUFOVL   EQU  MUSBUF-#1800
;
;
;BIBLI.ASM
BIB      EQU  #4003

AIGUILLE EQU  BIB       ;A:No ss-prog,HL:Adresse table
RND      EQU  BIB+3     ;A:Val max -> A:Valeur (0<A<Val max+1)
GETVAR   EQU  BIB+6     ;IX:Table des variables -> HL:Variable
RDTAB16  EQU  BIB+9     ;HL:Table,A:Indice -> HL:Adresse
INDIR    EQU  BIB+12    ;HL:Adresse -> HL:Valeur
RDTAB    EQU  BIB+15    ;HL:Table,DE:Taille valeurs,A:Indice -> HL:Adresse
GETSTR   EQU  BIB+18    ;HL:Table,A:Indice -> HL:Chaine
GETJOY   EQU  BIB+21    ; -> A:Etat joystick
PAUSE    EQU  BIB+24    ;A:Duree en s. -> NZ=Hit key
REPONOFF EQU  BIB+27
DIMINUE  EQU  BIB+30    ;HL:VALEUR,B:POURCENTAGE -> HL:VALEUR
MULT     EQU  BIB+33
DIVISE   EQU  BIB+36
;
;DISC.ASM
DIS      EQU  BIB+39

READFILE EQU  DIS       ;HL:Nom fichier,DE:Adresse dimplantation
                        ;    -> BC:Longueur,DE:Adresse octet suivant
;
;FLECHE.ASM
FLE      EQU  DIS+3

AFLECHE  EQU  FLE
EFLECHE  EQU  FLE+3
GFLECH1  EQU  FLE+6     ; -> HL:Coordonnees de la fleche
GFLECH2  EQU  FLE+9     ; -> HL:Adresse ecran de la fleche
TFLECHE  EQU  FLE+12    ; -> A:Octet ecran pointe par la fleche
MFLECHE  EQU  FLE+15    ;C=Init speed -> A:Etat joystick
;
;MUSINT.ASM
MUS      EQU  FLE+18

BRUIT    EQU  MUS
LOADMUS  EQU  MUS+3     ;HL:Nom fichier musique
ONOFF    EQU  MUS+6
OFF      EQU  MUS+9
ON       EQU  MUS+12    ;HL:Adresse musique
;
;SCR.ASM
SCR      EQU  MUS+15

LOADSCR  EQU  SCR       ;HL:Nom de l'ecran
SAVESCR  EQU  SCR+3
RESTSCR  EQU  SCR+6
SETPAL   EQU  SCR+9     ;HL:Palette
BLACKOUT EQU  SCR+12
DECOMP   EQU  SCR+15    ;HL:Adresse image compactee
AFFIMA   EQU  SCR+18    ;HL:Adresse image compactee
SETFLASH EQU  SCR+21
;
;SPRITE.ASM
SPR      EQU  SCR+24

LUTINIT  EQU  SPR
LUTIN    EQU  SPR+3     ;A:No sprite,HL:Coordonnees -> A:No lutin
LUTOUT   EQU  SPR+6     ;A:No lutin
LUTON    EQU  SPR+9     ;A:No lutin
LUTOFF   EQU  SPR+12    ;A:No lutin
LUTSAVE  EQU  SPR+15    ;A:No lutin
LUTMODV  EQU  SPR+18    ;A:No lutin,HL:Coordonnees,B:No sprite
AFFSPR   EQU  SPR+21    ;A:No sprite,HL:Coordonnees
PUTSPR   EQU  SPR+24    ;HL:Adresse ecran,DE:Sprite,B:Largeur,C:hauteur
GETSPR   EQU  SPR+27    ;HL:Table sprites,A:No sprite
                        ; -> HL:Sprite,B:Largeur,C:Hauteur
WHATREG  EQU  SPR+30    ; -> C=Trouve,A:No region
SCRADD   EQU  SPR+33
NEXTLINE EQU  SPR+36
AFFSPRB  EQU  SPR+39
AFFSPRC  EQU  SPR+42
PUTSPRB  EQU  SPR+45
ANIMATE  EQU  SPR+48
MILPAUSE EQU  SPR+51
ANIMATEB EQU  SPR+54
GETLUT   EQU  SPR+57
LUTMSCR  EQU  SPR+60
LUTSCRM  EQU  SPR+63
AFFREG   EQU  SPR+66
;
;TXT.ASM
TXT      EQU  SPR+69

AFFMESS  EQU  TXT
AFFMEBIS EQU  TXT+3     ;HL:Texte -> HL:Octet apres texte
MENUTEXT EQU  TXT+6     ;HL:Texte -> A:Option,HL:Octet apres texte
MENUSEL  EQU  TXT+9     ; -> A:option
MENUTEX0 EQU  TXT+12
MENUREST EQU  TXT+15
MENUTEX1 EQU  TXT+18
;
;DIVERS.ASM
DIV      EQU  TXT+21

KILL     EQU  DIV
GETREG   EQU  DIV+3
GETLORD  EQU  DIV+6
LGETHOME EQU  DIV+9
LGETYPE  EQU  DIV+12
LGETREG  EQU  DIV+15
LGETHATE EQU  DIV+18
LGETSOLD EQU  DIV+21
LPUTSOLD EQU  DIV+24
LGETCHEV EQU  DIV+27
LPUTCHEV EQU  DIV+30
LGETCATA EQU  DIV+33
LPUTCATA EQU  DIV+36
LGETGOLD EQU  DIV+39
LPUTGOLD EQU  DIV+42
LGETWIFE EQU  DIV+45
RGETSOLD EQU  DIV+48
RPUTSOLD EQU  DIV+51
RGETCHEV EQU  DIV+54
RPUTCHEV EQU  DIV+57
RGETCATA EQU  DIV+60
RPUTCATA EQU  DIV+63
RGETPROP EQU  DIV+66
RGETBUIL EQU  DIV+69
RGETINC  EQU  DIV+72
RGETVASS EQU  DIV+75
LGETINC  EQU  DIV+78
LGETARM  EQU  DIV+81
SALAIRE  EQU  DIV+84
ENCAISSE EQU  DIV+87
PAYE     EQU  DIV+90
TST_MONY EQU  DIV+93
PAYE_PC  EQU  DIV+96
RETIRE   EQU  DIV+99
GOHOME   EQU  DIV+102
GO       EQU  DIV+105
KADO     EQU  DIV+108
ISHERE   EQU  DIV+111
ISDEAD   EQU  DIV+114
ISSAX    EQU  DIV+117
ISNORM   EQU  DIV+120
ISJOUEUR EQU  DIV+123
BELONG   EQU  DIV+126
LANDFREE EQU  DIV+129
LTESTARM EQU  DIV+132
ADJACENT EQU  DIV+135
EXECARTE EQU  DIV+138
GETLNAME EQU  DIV+141
GETRNAME EQU  DIV+144
PLACARD  EQU  DIV+147
AFFMAP   EQU  DIV+150
REG_REG  EQU  DIV+153
REG_DAT  EQU  DIV+156
CHOIXREG EQU  DIV+159
CHEMIN   EQU  DIV+162
DEPLACE  EQU  DIV+165
;
;DATA
DAT      EQU  DIV+168

RETSIEGE EQU  DAT
ANIBUF   EQU  DAT+2
LORD     EQU  DAT+4
LUTTAB   EQU  DAT+6
;
;ATTAK.ASM
ATTAK    EQU  DAT+8

ATTAQUE  EQU  ATTAK
LORDHERE EQU  ATTAK+3
LORDNEAR EQU  ATTAK+6
RAMENE   EQU  ATTAK+9
TRANSFER EQU  ATTAK+12
RAPATRIE EQU  ATTAK+15

AFFARM   EQU  ATTAK+18
AFFINC   EQU  ATTAK+21
AFFLAND  EQU  ATTAK+24
LGETPREF EQU  ATTAK+27